<?php
/*
 * page appellée en premier au boot iPXE
 * adresse mac en argument
 *
 * si la machine est enregistrée et qu'une action est programmée, lance l'action
 * on peut durant 1 s choisir autre chose.
 *
 * si la machine n'est pas référencée, on attend 10s
 *
 * @TODO ajouter une detection de l'user-agent ?
 */
require "config.inc.php";
require "ldap.inc.php";
require "actions.inc.php";
require "partages.inc.php";
require "ipxe_functions.inc.php";

$ip = $_SERVER["REMOTE_ADDR"];
if (isset($_POST['mac'])) {
    $mac = $_POST['mac'];
} else {
    header("Content-type: text/plain");
    echo "#!ipxe\n";
    echo "params\n";
    echo "param mac \${net0/mac}\n";
    echo "chain --replace --autofree boot.php##params\n || sleep 10\n";
    exit();
}
$machine = get_action($config, $mac);
if (count($machine) > 0) {
    $id = $machine['netbootinitialization'] ?? "";
    $token = $machine['netbootmachinefilepath'] ?? "";
    $menu_timeout = '5000';
    //if (! empty($id) && ($id != "default"))
    if (isset($machine['action'][$token]['script']) && !empty($machine['action'][$token]['script'])){
        $menu_action = "action";
        $type = $machine['action']['type'];
        $script = $machine['action'][$token]['script'];
        $role = $machine['action'][$token]['role'] ?? "";
        $ret = $machine['action'][$token]['ret'] ?? -1;
    } else {
        $script = "default";
        $token = "";
        $menu_action = "default";
    }
} else {
    $script = "default";
    $menu_timeout = '10000';
    $token = "";
    $menu_action = "default";
}
$name = $machine['cn'] ?? "inconnu";
$url = "http://{$_SERVER["SERVER_ADDR"]}:{$_SERVER["SERVER_PORT"]}/ipxe/";

header("Content-type: text/plain");
echo "#!ipxe\n";
// set resolution and background
echo "console --x 1024 --y 768 --picture {$url}png/ipxe-se4.png\n";

echo ":menu\n";
echo "menu Preboot eXecution Environment pour mac : $mac\n";
echo "set menu-default " . $menu_action . "\n";
echo "set menu-timeout $menu_timeout\n";

title("Choisir une action :");
echo "item --key 1 login (1) Acces au menu d'administration\n";
echo "item --key 2 action (2) Action programmee : type : \"" . @$type . "\", action : \"" . @$script . "\", machine : \"" . @$name . "\" etape : \"" . @$ret . "\"\n";
echo "item --key 3 default (3) Quitter iPXE et booter sur le BIOS\n";

echo "choose --default \${menu-default} --timeout \${menu-timeout} selected && goto \${selected} || exit 0\n";

echo ":login\n";
echo "login\n";
echo "isset \${username} && isset \${password} || goto menu\n";
echo "params\n";
echo "param mac \${net0/mac}\n";
echo "param username \${username}\n";
echo "param password \${password}\n";
echo "chain --replace --autofree {$url}admin.php##params\n || sleep 10\n";

echo ":action\n";
echo "params\n";
echo "param mac \${net0/mac}\n";
echo "param token $token\n";
echo "param action $script\n";
echo "chain --replace --autofree " . $url . "action.php##params\n || sleep 10\n";

echo ":default\n";
echo "echo Demarrage sur les disques locaux...\n";
echo "echo Boot Disque 1...\n";
echo boot_disk();

///////////// vérification des acls sur os ////////////////////
$acls = array(
    "user::rwx",
    "user:www-admin:rwx",
    "user:admin:rwx",
    "user:www-data:r-x",
    "group::r-x",
    "group:domain\\040admins:r-x",
    "group:domain\\040computers:r-x",
    "mask::rwx",
    "other::---",
    "default:user::rwx",
    "default:user:www-admin:rwx",
    "default:user:admin:rwx",
    "default:user:www-data:r-x",
    "default:group::r-x",
    "default:group:domain\\040admins:r-x",
    "default:group:domain\\040computers:r-x",
    "default:mask::rwx",
    "default:other::---"
);
if (! @check_acls("/var/sambaedu/unattended/install/os", $acls))
    @set_acls("/var/sambaedu/unattended/install/os", $acls);
    
?>
