<?php
/*
 * choix du nom de la machine, et enregistrement dans l'annuaire AD
 */
require "config.inc.php";
require "ldap.inc.php";
require "actions.inc.php";
require_once ('ipxe_functions.inc.php');

header("Content-type: text/plain");
echo "#!ipxe\n";
$menu_timeout = '10000';
echo "console --x 1024 --y 768 --picture png/ipxe-se4.png\n";
$token = $_POST['token'] ?? "";
$mac = $_POST['mac'] ?? "none";
$name = $_POST['name'] ?? "";
if (auth_action($config, $mac, $token)) {
    $machine = get_action($config, $mac, $token);
    if (isset($machine['cn'])) {
        $registered_name = $machine['cn'];
    } else {
        $registered_name = "";
    }
    if (! empty($_POST['new_name'])) {
        $new_name = substr($_POST['new_name'], 0, 15);
        if ($registered_name == $new_name) {
            echo "params\n";
            echo "param token " . $token . "\n";
            echo "param mac " . $mac . "\n";
            echo "param name " . $new_name . "\n";
            echo "param menu-default set-name\n";
            echo "echo La machine est deja enregistree sous ce nom " . $new_name . "\n";
            echo "sleep 3\n";
            echo "chain --replace --autofree admin.php##params\n";
        } elseif ($registered_name != "") {
            delete_ad($config, $registered_name, "computer");
        }
        if (count(search_machine($config, $new_name)) == 0) {
            // on crée une machine avec un enregistrement mac, mais on ne définit pas d'ip réservée à ce stade.
            $res = create_machine($config, $new_name, $config['computers_rdn'], "reservation iPXE");
        } else {
            $res = true;
        }
        if ($res) {
            $attrs = array(
                'networkaddress' => $mac,
                'netbootmachinefilepath' => $token
            );
            $mode = "add";
            $res = modify_ad($config, $new_name, "machine", $attrs, $mode);
        }
        if ($res) {
            delete_action($mac);
            echo "params\n";
            echo "param token " . $token . "\n";
            echo "param mac " . $mac . "\n";
            echo "param name " . $new_name . "\n";
            echo "param menu-default dhcp\n";
            echo "echo OK ! nom " . $new_name . " reserve pour " . $mac . "\n";
            echo "sleep 3\n";

            echo "chain --replace --autofree admin.php##params\n";
        } else {
            echo "params\n";
            echo "param token " . $token . "\n";
            echo "param mac " . $mac . "\n";
            echo "param name " . $new_name . "\n";
            echo "param menu-default set-name\n";
            echo "echo ERREUR ! nom " . $new_name . " invalide pour " . $mac . "\n";
            echo "sleep 3\n";
            echo "chain --replace --autofree admin.php##params\n";
        }
    } else {

        echo "echo Enregistrement du nom pour nom : " . $name . ", mac : " . $mac . " \n";
        echo "echo -n Entrez le nom de la machine : \n";
        echo "set name " . $name . "\n";
        echo "read name\n";
        echo "params\n";
        echo "param token " . $token . "\n";
        echo "param mac " . $mac . "\n";
        echo "param new_name \${name}\n";
        echo "chain --replace --autofree enregistrement.php##params\n";
    }
} else {
    echo "params\n";
    echo "param mac '" . $mac . "'\n";
    echo "param token " . $token . "\n";
    echo "echo ERREUR ! acces refuse\n";
    echo "sleep 3\n";   
    echo "chain --replace --autofree admin.php##params\n";
}
?>
 